
SendDvorak_ExtendedIM_IME_Off:
	if A_ThisHotkey not contains *
	{
		StringTrimRight, Dvorak_key, Dvorak_%A_ThisHotkey%, 0
	}
	else
	{
		Dvorak_key = 
	}

	Send,%Dvorak_key%
return


SendDvorak_ExtendedIM_IME_On:
	if A_ThisHotkey not contains *
	{
		StringTrimRight, Dvorak_key, Dvorak_%A_ThisHotkey%, 0
	}
	else
	{
		Dvorak_key = 
	}

	IfLess, IME_ConvMode, 16 ; ȓ͗p
	{
		Send,{%A_ThisHotkey%}
	}
	else
	{
		If A_PriorHotkey contains ~,*,^,#,!
		{
			Prior_Dvorak_key =
		}
		else
		If A_PriorHotkey contains  +,&
		{
			IfInString, A_PriorHotkey, +
			{
				StringTrimLeft, Prior_Dvorak_key, A_PriorHotkey, 1
			}
			else
			IfInString, A_PriorHotkey, &
			{
				StringTrimLeft, Prior_Dvorak_key, A_PriorHotkey, 8
			}


			StringTrimRight, Prior_Dvorak_key, Dvorak_shift_%Prior_Dvorak_key%, 0
		}
		else
		{
			StringTrimRight, Prior_Dvorak_key, Dvorak_%A_PriorHotkey%, 0
		}



		IfEqual, Is_Hyphen_to_Enter, 1
		{
			IfInString, Dvorak_key, -
			{
					Dvorak_key = {Enter}
			}
		}


		IfEqual, Extended_IM_Which, 2
		{
			if Dvorak_key in ,,,`',.,`;,q,j,k,x,a,o,e,u,i
			{
				SendDvorakJP_Vowel(Dvorak_key, Prior_Dvorak_key)
			}
			else
			if Dvorak_key in p,y,f,g,c,r,l,d,h,t,n,s,b,m,w,v,z
			{
				SendDvorakJP_Consonant(Dvorak_key, Prior_Dvorak_key)
			}
			else
			{
				Send,%Dvorak_key%
			}
		}
		else
		IfEqual, Extended_IM_Which, 3
		{
			if Dvorak_key in c,`;,q,j,k,x
			{
				SendDvorakY(Dvorak_key)
			}
			else
			{
				Send,%Dvorak_key%
			}
		}
		else
		IfEqual, Extended_IM_Which, 4
		{
			if Dvorak_key in ,,,`',.,p,y,a,o,e,u,i,`;,q,j,k,x
			{
				SendACT09_Vowel(Dvorak_key, Prior_Dvorak_key)
			}
			else
			if Dvorak_key in f,g,c,r,l,d,h,t,n,s,b,m,w,v,z
			{
				SendACT09_Consonant(Dvorak_key, Prior_Dvorak_key)
			}
			else
			{
				Send,%Dvorak_key%
			}
		}
		else
		IfEqual, Extended_IM_Which, 5
		{
			SendSousei_Normal(Dvorak_key, Prior_Dvorak_key)
		}
		else
		IfEqual, Extended_IM_Which, 6
		{
			if Dvorak_key in ,,,`',.,p,y,a,o,e,u,i,`;,q,j,k,x
			{
				SendJLOD_Vowel(Dvorak_key, Prior_Dvorak_key)
			}
			else
			if Dvorak_key in f,g,c,r,l,d,h,t,n,s,b,m,w,v,z
			{
				SendJLOD_Consonant(Dvorak_key, Prior_Dvorak_key)
			}
			else
			{
				Send,%Dvorak_key%
			}
		}
		else
		IfEqual, Extended_IM_Which, 7 ; ʔz
		{
			if Dvorak_key in -
				Send,{BackSpace}
			else
			if Dvorak_key in /
				onKeyDown("_AT")
			else
			if Dvorak_key in s
				onKeyDown("_SColon")
			else
			if Dvorak_key in w
				onKeyDown("_Comma")
			else
			if Dvorak_key in v
				onKeyDown("_Dot")
			else
			if Dvorak_key in =
				Send,^c
			else
			if Dvorak_key in ,,,`',.,`;,/,q,j,k,x,p,y,f,g,c,r,l,a,o,e,u,i,d,h,t,n,b,m
			{
				StringTrimRight, QWERTY_key, QWERTY_%A_ThisHotkey%, 0
				StringUpper, QWERTY_key, QWERTY_key
				QWERTY_key = _%QWERTY_key%
				onKeyDown(QWERTY_key)
			}
			else
				Send,%Dvorak_key%
		}
		else
		if Extended_IM_Which in 8,9 ; h艺ʔzƍh艺ʔz
		{
			if Dvorak_key in -
				Send,{Enter}
			else
			if Dvorak_key in /
				onKeyDown("_AT")
			else
			if Dvorak_key in s
				onKeyDown("_SColon")
			else
			if Dvorak_key in w
				onKeyDown("_Comma")
			else
			if Dvorak_key in v
				onKeyDown("_Dot")
			else
			if Dvorak_key in z
				onKeyDown("_Slash")
			else
			if Dvorak_key in \
				onKeyDown("_BackSlash")
			else
			if Dvorak_key in =
				Send,^c
			else
			if Dvorak_key in ``
				Send,^x
			else
			if Dvorak_key in [
				Send,^v
			else
			if Dvorak_key in ]
				Send,{ESC}
			else
			if Dvorak_key in ,,,`',.,`;,/,q,j,k,x,p,y,f,g,c,r,l,a,o,e,u,i,d,h,t,n,b,m
			{
				StringTrimRight, QWERTY_key, QWERTY_%A_ThisHotkey%, 0
				StringUpper, QWERTY_key, QWERTY_key
				QWERTY_key = _%QWERTY_key%
				onKeyDown(QWERTY_key)
			}
			else
				Send,%Dvorak_key%
		}
		else
		{
			IfEqual, Special_extension, 1
			{
				SendSpecial_Key(Dvorak_key)
			}
			else
			{
				Send,%Dvorak_key%
			}
		}
	}

return



SendDvorak_ExtendedIMShift_IME_Off:
	IfInString, A_ThisHotkey, +
	{
		StringTrimLeft, this_key, A_ThisHotkey, 1
	}
	IfInString, A_ThisHotkey, &
	{
		StringTrimLeft, this_key, A_ThisHotkey, 8
	}

	StringTrimRight, Dvorak_key, Dvorak_shift_%this_key%, 0


	Send,%Dvorak_key%
return


SendDvorak_ExtendedIMShift_IME_On:
	IfInString, A_ThisHotkey, +
	{
		StringTrimLeft, this_key, A_ThisHotkey, 1
	}
	IfInString, A_ThisHotkey, &
	{
		StringTrimLeft, this_key, A_ThisHotkey, 8
	}

	StringTrimRight, Dvorak_key, Dvorak_shift_%this_key%, 0


	IfLess, IME_ConvMode, 16 ; ȓ͗p
	{
		Send,+{%this_key%}
	}
	else
	IfEqual, Extended_IM_Which, 5
	{
		If A_PriorHotkey contains ~,*,^,#
		{
			Prior_Dvorak_key = 
		}
		else
		If A_PriorHotkey contains +,&
		{
			IfInString, A_PriorHotkey, +
			{
				StringTrimLeft, Prior_Dvorak_key, A_PriorHotkey, 1
			}
			else
			IfInString, A_PriorHotkey, &
			{
				StringTrimLeft, Prior_Dvorak_key, A_PriorHotkey, 8
			}


			StringTrimRight, Prior_Dvorak_key, Dvorak_shift_%Prior_Dvorak_key%, 0
		}
		else
		{
			StringTrimRight, Prior_Dvorak_key, Dvorak_%A_PriorHotkey%, 0
		}


		SendSouseiShift(Dvorak_key, Prior_Dvorak_key)
	}
	else
	{
		Send,%Dvorak_key%
	}
return








onKeyUp:
	if(bufKey)
	{
		outputChar(singleStroke%bufKey%)
		bufKey = 0
	}
	setTimer, onKeyUp, Off
Return

onOnKeyDown:

	inputTime = %A_TickCount%

	if(bufKey){
		; GapTime elł邩
		if( inputTime-bufTime <= MaximalGT )
		{
			currentKeyPattern:=flag%gDownKeyName%|flag%bufKey%
			Loop, %NumberOfKCmb%
			{
				; ̑gݍ킹`Ă邩
				if( KCmb%A_Index% == currentKeyPattern)
				{
					IfEqual, Extended_IM_Which, 7
					{
						if A_Index in 147,150,159
						{
							ConvABCMode = 1
							IME_ConvMode := IME_GetConvMode()
							IME_SetConvMode(24)
						}
					}

					; ŌóAobt@ƃ^C}[NA
					outputChar( resultOfKCmb%A_Index%)
					bufKey = 0
					setTimer, onKeyUp, Off

					Return
				}
			}
		}
		; ŌłȂobt@m
		outputChar( singleStroke%bufKey%)
	}
	; obt@XVA^C}[ݒ
	bufTime = %inputTime%
	bufKey = %gDownKeyName%
	setTimer, onKeyUp, %MaximalGT%

	gDownKeyName = 0
Return

IME_GET:
	IfEqual, Extended_IM_On_Off, 1
	{
		IfNotEqual, IME_Mode, 0
		{
			IME_Mode = 0

			Loop, parse, ScanCode, |,
			{
				Hotkey, sc0%A_LoopField%, SendDvorak_ExtendedIM_IME_Off
				Hotkey, +sc0%A_LoopField%, SendDvorak_ExtendedIMShift_IME_Off
				Hotkey, Space & sc0%A_LoopField%, SendDvorak_ExtendedIMShift_IME_Off
			}
		}
	}
	else
	IfEqual, Extended_IM_On_Off, 2
	{
		IfEqual, IME_Mode, 0
		{
			IME_Mode := IME_GET()

			IfEqual, IME_Mode, 1
			{
				Loop, parse, ScanCode, |,
				{
					Hotkey, sc0%A_LoopField%, SendDvorak_ExtendedIM_IME_On
					Hotkey, +sc0%A_LoopField%, SendDvorak_ExtendedIMShift_IME_On
					Hotkey, Space & sc0%A_LoopField%, SendDvorak_ExtendedIMShift_IME_On
				}
			}
		}
		else
		{
			IME_Mode := IME_GET()

			IfEqual, IME_Mode, 0
			{
				Loop, parse, ScanCode, |,
				{
					Hotkey, sc0%A_LoopField%, SendDvorak_ExtendedIM_IME_Off
					Hotkey, +sc0%A_LoopField%, SendDvorak_ExtendedIMShift_IME_Off
					Hotkey, Space & sc0%A_LoopField%, SendDvorak_ExtendedIMShift_IME_Off
				}
			}
		}
	}
	else
	IfEqual, Extended_IM_On_Off, 3
	{
		IME_GET()

		IfNotEqual, IME_Mode, 1
		{
			IME_Mode = 1

			Loop, parse, ScanCode, |,
			{
				Hotkey, sc0%A_LoopField%, SendDvorak_ExtendedIM_IME_On
				Hotkey, +sc0%A_LoopField%, SendDvorak_ExtendedIMShift_IME_On
				Hotkey, Space & sc0%A_LoopField%, SendDvorak_ExtendedIMShift_IME_On
			}
		}
	}


	IfEqual, IME_Mode, 1
	{
		IfEqual, IME_ConvMode,
		{
			IME_ConvMode := IME_GetConvMode()
		}


		IfEqual, ConvABCMode, 1
		{
			ConvABCMode = 0
			IME_SetConvMode(IME_ConvMode)
		}
	}

return





JCtrl_10:
	Send,{Home}
return

JCtrl_11:
	Send,+{Left}
return

JCtrl_12:
	Send,{Up}
return

JCtrl_13:
	Send,+{Right}
return

JCtrl_14:
	Send,{End}
return

JCtrl_15:
	Send,!
return

JCtrl_16:
	Send,^u
return

JCtrl_17:
	Send,^i
return

JCtrl_18:
	Send,^o
return

JCtrl_19:
	Send,^p
return

JCtrl_1E:
	Send,^{BS}
return

JCtrl_1F:
	Send,{Left}
return

JCtrl_20:
	Send,{Down}
return

JCtrl_21:
	Send,{Right}
return

JCtrl_22:
	Send,{Del}
return

JCtrl_23:
	Send,{BS}
return

JCtrl_24:
	Send,{ESC}
return

JCtrl_25:
	Send,{AppsKey}
return

JCtrl_26:
	Send,^s
return

JCtrl_27:
	Send,^a
return

JCtrl_2C:
	Send,^z
return

JCtrl_2D:
	Send,^x
return

JCtrl_2E:
	Send,^c
return

JCtrl_2F:
	Send,^v
return

JCtrl_30:
	Send,{LWin}
return

JCtrl_31:
	Send,#{Tab}
return

JCtrl_32:
	Send,{Enter}
return

JCtrl_33:
	Send,#m
return

JCtrl_34:
	Send,!es
return

JCtrl_35:
	Send,^z
return


SpecialKey_1:
	gosub,SpecialKey_for_CapsLock_or_Hiragana
	Send,{%A_ThisHotkey%}
return

SpecialKey_2:
	gosub,SpecialKey_for_CapsLock_or_Hiragana
	Send,{Enter}
return

SpecialKey_3:
	gosub,SpecialKey_for_CapsLock_or_Hiragana
	Send,{ESC}
return

SpecialKey_4:
	gosub,SpecialKey_for_CapsLock_or_Hiragana
	Send,{BS}
return

SpecialKey_5:
	gosub,SpecialKey_for_CapsLock_or_Hiragana
	Send,{Del}
return

SpecialKey_6:
	gosub,SpecialKey_for_CapsLock_or_Hiragana
	Send,{vkF0sc03A}
return

SpecialKey_7:
	gosub,SpecialKey_for_CapsLock_or_Hiragana
	Send,{vk1Dsc07B}
return

SpecialKey_8:
	gosub,SpecialKey_for_CapsLock_or_Hiragana
	Send,{vk1Csc079}
return

SpecialKey_9:
	gosub,SpecialKey_for_CapsLock_or_Hiragana
	Send,{vkF2sc070}
return

SpecialKey_10:
	gosub,SpecialKey_for_CapsLock_or_Hiragana
	Send,{vkF3sc029}
return

SpecialKey_11:
	gosub,SpecialKey_for_CapsLock_or_Hiragana
	IME_SET(0)
return

SpecialKey_12:
	gosub,SpecialKey_for_CapsLock_or_Hiragana
	IME_SET(1)
return


; CapsLock AЂ炪ȃL[Ȃ΁Aグ

SpecialKey_for_CapsLock_or_Hiragana:
	IfEqual, A_ThisHotkey, sc03A
	{
		Send,{vkF0sc03A up}
	}
	else
	IfEqual, A_ThisHotkey, sc070
		Send,{vkF0sc070 up}
return

